Index: loader/source/update-bios.c
===================================================================
--- loader/source/update-bios.c	(nonexistent)
+++ loader/source/update-bios.c	(working copy)
@@ -0,0 +1,570 @@
+/*
+
+Nintendont (Loader) - Playing Gamecubes in Wii mode on a Wii U
+
+Copyright (C) 2014  JoostinOnline
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation version 2.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+
+#include <gccore.h>
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <malloc.h>
+#include <network.h>
+
+#include <zlib.h>
+#include <ogc/lwp_watchdog.h>
+
+#include "exi.h"
+#include "FPad.h"
+#include "font.h"
+#include "global.h"
+#include "http.h"
+#include "menu.h"
+#include "update.h"
+#include "ff_utf8.h"
+#include "unzip/miniunz.h"
+#include "unzip/ioapi.h"
+#include "../../common/include/NintendontVersion.h"
+extern void changeToDefaultDrive();
+extern char launch_dir[MAXPATHLEN];
+extern int selected;
+
+typedef struct {
+	const char url[96];
+	const char text[30];
+	const char filename[30];
+	const u32 max_size;
+} downloads_t;
+
+typedef enum {
+	DOWNLOAD_TITLES,
+	DOWNLOAD_CONTROLLERS,
+	DOWNLOAD_THEMES,
+	DOWNLOAD_CLASSIC,
+	DOWNLOAD_AAA,
+	DOWNLOAD_BBB,	
+	DOWNLOAD_CCC,
+	DOWNLOAD_D1,
+	DOWNLOAD_D2,
+	DOWNLOAD_D3,
+	DOWNLOAD_D4,	
+	DOWNLOAD_D5	
+} DOWNLOADS;
+
+static const downloads_t Downloads[] = {
+	{"http://nintendont.gxarena.com/themes/titles.zip", "Updating titles.txt", "titles.zip", 0x80000}, // 512KB
+	{"http://nintendont.gxarena.com/themes/controllers.zip", "Updating controllers.zip", "controllers.zip", 0x8000}, // 32KB
+	{"http://send0r.de/Nintendont/MasterMod/iplall.zip", "Downloading Bios", "iplall.zip", 0x800000}, // 8MB
+	{"http://send0r.de/Nintendont/MasterMod/iplusa.zip", "Downloading Bios", "iplusa.zip", 0x400000}, // 4MB
+	{"http://send0r.de/Nintendont/MasterMod/iplpal.zip", "Downloading Bios", "iplpal.zip", 0x400000}, // 4MB
+	{"http://send0r.de/Nintendont/MasterMod/ipljap.zip", "Downloading Bios", "ipljap.zip", 0x400000}, // 4MB
+	{"http://send0r.de/Nintendont/MasterMod/segaboot.zip", "Downloading Bios", "segaboot.zip", 0x400000}, // 4MB
+	{"http://send0r.de/Nintendont/MasterMod/iplall.zip", "Downloading Bios", "iplall.zip", 0x800000}, // 8MB
+	{"http://send0r.de/Nintendont/MasterMod/iplusa.zip", "Downloading Bios", "iplusa.zip", 0x400000}, // 4MB
+	{"http://send0r.de/Nintendont/MasterMod/iplpal.zip", "Downloading Bios", "iplpal.zip", 0x400000}, // 4MB
+	{"http://send0r.de/Nintendont/MasterMod/ipljap.zip", "Downloading Bios", "ipljap.zip", 0x400000}, // 4MB
+	{"http://send0r.de/Nintendont/MasterMod/segaboot.zip", "Downloading Bios", "segaboot.zip", 0x400000}, // 4MB	
+};
+
+static int UnzipTitles(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_TITLES].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_TITLES].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_TITLES].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipControllers(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/controllers";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_CONTROLLERS].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_CONTROLLERS].filename);
+	
+	f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_mkdir_char(unzip_directory); // attempt to make dir
+	if (f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_CONTROLLERS].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipThemes(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_THEMES].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_THEMES].filename);
+	
+	f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_THEMES].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipClassic(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_CLASSIC].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_CLASSIC].filename);
+	
+	f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_CLASSIC].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipAaa(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_AAA].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_AAA].filename);
+	
+	f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_AAA].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipBbb(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_BBB].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_BBB].filename);
+	
+	f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_BBB].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipCcc(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_CCC].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_CCC].filename);
+	
+	f_chdrive_char(UseSD ? "sd:" : "usb:");
+	f_chdir_char("/");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_CCC].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static s32 Download(DOWNLOADS download_number)  {
+	ClearScreen();
+	
+	int line = 1;
+	int ret;
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	char filepath[MAXPATHLEN];
+	bool dir_argument_exists = strlen(launch_dir);
+	snprintf(filepath, sizeof(filepath), "%s%s", dir_argument_exists ? launch_dir : "/", Downloads[download_number].filename);
+				if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+	UpdateScreen();
+	
+	line++;
+	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
+	ret = net_init();
+	if(ret < 0) {
+		gprintf("Failed to init network\r\n");
+		goto end;
+	}
+	gprintf("Network Initialized\r\n");
+				if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+	UpdateScreen();
+	
+	int i;
+	for (i = 0; i <= 10; i++) {
+		ret = http_request(Downloads[download_number].url, Downloads[download_number].max_size);
+		if (ret) break;
+		if (i == 10) {
+			gprintf("Error making http request\r\n");
+			ret = -1;
+			goto end;
+		}
+	}
+
+	ret = http_get_result(&http_status, &outbuf, &filesize); 
+	if(((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		ret = -2;
+		goto end;
+	}
+	UpdateScreen();
+	line++;
+	if (!dir_argument_exists) {
+		gprintf("Creating new directory\r\n");
+	}
+				// Write the file to disk.	
+		if (download_number == DOWNLOAD_TITLES) {ret = UnzipTitles(outbuf, filesize);}		
+		else if (download_number == DOWNLOAD_CONTROLLERS) {ret = UnzipControllers(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_THEMES) {ret = UnzipThemes(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_CLASSIC) {ret = UnzipClassic(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_AAA) {ret = UnzipAaa(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_BBB) {ret = UnzipBbb(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_CCC) {ret = UnzipCcc(outbuf, filesize);}
+		else
+	{
+		FIL file;
+		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
+			gprintf("File Error\r\n");
+			ret = -3;
+			goto end;
+		} else {
+			UINT wrote;
+			f_write(&file, outbuf, filesize, &wrote);
+			f_close(&file);
+			ret = 1;			
+		}
+	}
+	if (ret == 1) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+		UpdateScreen();
+		line++;
+	}
+end:
+	if (ret != 1)
+		{
+			if (which_bg == BG_NONE)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+			else if (which_bg == BG_LEGACY)
+			PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+		}
+			else if ((download_number == DOWNLOAD_TITLES) || (download_number == DOWNLOAD_CONTROLLERS))
+			{
+			if (which_bg == BG_NONE)
+			{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");}
+			}	
+			else {
+	if (which_bg == BG_NONE)
+	{PrintFormat(31, 0x80000000, MENU_POS_X, MENU_POS_Y + 20*(line+15), "GameCube Bios Download Complete");}
+	else if (which_bg == BG_LEGACY)
+	{PrintFormat(31, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line+15), "GameCube Bios Download Complete");}}
+	UpdateScreen();
+	if (outbuf != NULL) free(outbuf);
+	net_deinit();
+	sleep(2);
+	return ret;
+}
+
+void UpdateBios(void) {
+	selected = 0;
+	u64 delay = ticks_to_millisecs(gettime()) + 500;
+	while(true) {
+		ClearScreen();
+					if (which_bg == BG_NONE)
+					{		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Nintendont Extras Download Menu");
+		PrintFormat(27, BLACK, MENU_POS_X, MENU_POS_Y + 20*19, "PAL Bios is not compatible with WiiU");		
+		PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");	
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Game Titles File");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download HID Controllers Pack");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download All Bios Files");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download USA Bios Only");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Download PAL Bios Only");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Download JAP BIOS Only");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Download Triforce BIOS Only");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Delete All Bios Files");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Delete USA Bios Only");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Delete PAL Bios Only");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*14, "Delete JAP BIOS Only");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*15, "Delete Triforce BIOS Only");			
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*16, "Return to Update Menu");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+					else if (which_bg == BG_LEGACY)
+					{		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "Nintendont Extras Download Menu");	
+		PrintFormat(27, WHITE, MENU_POS_X, MENU_POS_Y + 20*19, "PAL Bios is not compatible with WiiU");		
+		PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");		
+		PrintInfo();
+		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Game Titles File");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download HID Controllers Pack");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download All Bios Files");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download USA Bios Only");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Download PAL Bios Only");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Download JAP BIOS Only");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Download Triforce BIOS Only");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Delete All Bios Files");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Delete USA Bios Only");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Delete PAL Bios Only");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*14, "Delete JAP BIOS Only");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*15, "Delete Triforce BIOS Only");			
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*16, "Return to Update Menu");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+		//////////
+		if (f_chdir_char("/apps/Nintendont/Preview/bios") == FR_OK){
+		Preview();}
+		//////////
+		GRRLIB_Render();
+		FPAD_Update();
+		if (delay > ticks_to_millisecs(gettime())) continue;
+		if (FPAD_Start(1)) {
+			ClearScreen();
+						if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader...");}
+			ExitToLoader(0);
+		}
+			if (FPAD_OK(1)) {
+			f_chdir_char("/");
+			if (selected <= (DOWNLOAD_CCC))
+			Download(selected);
+			else if (selected == (DOWNLOAD_D1))
+				{
+				if (UseSD) {
+				f_unlink_char( "sd:/iplpal.bin" );
+				f_unlink_char( "sd:/iplusa.bin" );
+				f_unlink_char( "sd:/ipljap.bin" );
+				f_unlink_char( "sd:/segaboot.bin" );}
+				else {
+				f_unlink_char( "usb:/iplpal.bin" );
+				f_unlink_char( "usb:/iplusa.bin" );
+				f_unlink_char( "usb:/ipljap.bin" );
+				f_unlink_char( "usb:/segaboot.bin" );}
+				ClearScreen();
+			//BackTheme();
+			if (which_bg == BG_NONE)
+			{PrintFormat(31, BLACK, MENU_POS_X, MENU_POS_Y + 20*10, "Bios Files Successfully Deleted");}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(31, WHITE, MENU_POS_X, MENU_POS_Y + 20*10, "Bios Files Successfully Deleted");}
+			UpdateScreen();
+			sleep (2);
+			UpdateBios();}
+			else if (selected == (DOWNLOAD_D2))
+				{
+				if (UseSD) {
+				f_unlink_char( "sd:/iplusa.bin" );}
+				else {
+				f_unlink_char( "usb:/iplusa.bin" );}
+				ClearScreen();
+			//BackTheme();
+			if (which_bg == BG_NONE)
+			{PrintFormat(31, BLACK, MENU_POS_X, MENU_POS_Y + 20*10, "Bios File Successfully Deleted");}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(31, WHITE, MENU_POS_X, MENU_POS_Y + 20*10, "Bios File Successfully Deleted");}
+			UpdateScreen();
+			sleep (2);
+			UpdateBios();}
+			else if (selected == (DOWNLOAD_D3))
+				{
+				if (UseSD) {
+				f_unlink_char( "sd:/iplpal.bin" );}
+				else {
+				f_unlink_char( "usb:/iplpal.bin" );}
+				ClearScreen();
+			//BackTheme();
+			if (which_bg == BG_NONE)
+			{PrintFormat(31, BLACK, MENU_POS_X, MENU_POS_Y + 20*10, "Bios File Successfully Deleted");}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(31, WHITE, MENU_POS_X, MENU_POS_Y + 20*10, "Bios File Successfully Deleted");}
+			UpdateScreen();
+			sleep (2);
+			UpdateBios();}
+			else if (selected == (DOWNLOAD_D4))
+				{
+				if (UseSD) {
+				f_unlink_char( "sd:/ipljap.bin" );}
+				else {
+				f_unlink_char( "usb:/ipljap.bin" );}
+				ClearScreen();
+			//BackTheme();
+			if (which_bg == BG_NONE)
+			{PrintFormat(31, BLACK, MENU_POS_X, MENU_POS_Y + 20*10, "Bios File Successfully Deleted");}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(31, WHITE, MENU_POS_X, MENU_POS_Y + 20*10, "Bios File Successfully Deleted");}
+			UpdateScreen();
+			sleep (2);
+			UpdateBios();}
+			else if (selected == (DOWNLOAD_D5))
+				{
+				if (UseSD) {
+				f_unlink_char( "sd:/segaboot.bin" );}
+				else {
+				f_unlink_char( "usb:/segaboot.bin" );}
+				ClearScreen();
+			//BackTheme();
+			if (which_bg == BG_NONE)
+			{PrintFormat(31, BLACK, MENU_POS_X, MENU_POS_Y + 20*10, "Bios File Successfully Deleted");}
+			else if (which_bg == BG_LEGACY)
+			{PrintFormat(31, WHITE, MENU_POS_X, MENU_POS_Y + 20*10, "Bios File Successfully Deleted");}
+			UpdateScreen();
+			sleep (2);
+			UpdateBios();}			
+			else
+				break;
+		}
+		if (FPAD_Down(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected++;
+			if (selected > 12) selected = 0;
+		}
+		if (FPAD_Up(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected--;
+			if (selected < 0) selected = 12;
+		}
+		if(FPAD_Y(0)) {
+				Credits();
+		}
+		if (FPAD_Cancel(1)) {
+			break;
+		}
+	}
+	ClearScreen();
+	UpdateNintendont();
+}
\ No newline at end of file
